- name: Resolve current version
  set_fact:
    current_ldap_version: "{{ (ldap_dc.resources[0].spec.template.spec.containers[0].image.split(':'))[1]
                                  if (ldap_dc.resources[0].spec.template is defined
                                      and ldap_dc.resources[0].spec.template.spec is defined
                                      and ldap_dc.resources[0].spec.template.spec.containers is defined
                                      and ldap_dc.resources[0].spec.template.spec.containers[0] is defined
                                      and ldap_dc.resources[0].spec.template.spec.containers[0].image is defined
                                      and (ldap_dc.resources[0].spec.template.spec.containers[0].image.split(':')) | length == 2)
                                  else ((ldap_dc.resources[0].spec.template.spec.containers[0].image.split(':'))[2] | default('unknown')) }}"
- block:
  - name: Fails if current version unknown
    fail:
      msg: "OpenLDAP tag unknown {{ current_ldap_version }}"
    when:
    - current_ldap_version not in [ '2.4.58-1', '2.4.59-1', '2.5.7-1', '2.5.7-2', '2.5.8-1', '2.5.9-1', '2.5.11-1', '2.6.2-1', '2.6.2-2' ]
  - name: Checks upgrade supported
    fail:
      msg: "Can not upgrade from {{ current_ldap_version }} to {{ ldap_tag }}"
    when:
    - >
        (current_ldap_version == '2.6.2-1' and ldap_tag in [ '2.4.59-1', '2.4.58-1', '2.5.7-1', '2.5.7-2', '2.5.8-1', '2.5.9-1', '2.5.11-1' ])
        or (current_ldap_version == '2.5.11-1' and ldap_tag in [ '2.4.59-1', '2.4.58-1', '2.5.7-1', '2.5.7-2', '2.5.8-1', '2.5.9-1' ])
        or (current_ldap_version == '2.5.9-1' and ldap_tag in [ '2.4.59-1', '2.4.58-1', '2.5.7-1', '2.5.7-2', '2.5.8-1' ])
        or (current_ldap_version == '2.5.8-1' and ldap_tag in [ '2.4.59-1', '2.4.58-1', '2.5.7-1', '2.5.7-2' ])
        or (current_ldap_version == '2.5.7-2' and ldap_tag in [ '2.4.59-1', '2.4.58-1', '2.5.7-1' ])
        or (current_ldap_version == '2.5.7-1' and ldap_tag in [ '2.4.59-1', '2.4.58-1' ])
        or (current_ldap_version == '2.4.59-1' and ldap_tag in [ '2.4.58-1' ])
  - include_role:
      name: directory
      tasks_from: upgrade-step.yaml
    vars:
      target: "{{ ldap_tag }}"
    when:
    - current_ldap_version != ldap_tag
  when:
  - current_ldap_version != 'master'
  - current_ldap_version != 'devel'
  - current_ldap_version != 'stage'
- name: Issue a warning when migrating from master to release
  debug:
    msg: |
      WARNING - about to deploy {{ ldap_tag }} over CI version {{ current_ldap_version }}
  when:
  - current_ldap_version in [ 'master', 'devel', 'stage' ]
